﻿Public Class FormMain

    Public oFutekUSBDLL As New FUTEK_USB_DLL.USB_DLL

    Public SerialNumber As String
    Public DeviceHandle As String

    Public OffsetValue As String
    Public FullscaleValue As String

    Public FullScaleLoad As String
    Public DecimalPoint As String
    Public UnitCode As String
    Public Tare As String

    Public NormalData As String
    Public CalculatedReading As String

    Public OpenedConnection As Boolean

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Text = "Microsoft Visual Basic Example Using Futek USB DLL " +
                  System.Reflection.Assembly.GetAssembly(GetType(FUTEK_USB_DLL.USB_DLL)).GetName().Version.ToString()

        SerialNumber = ""
        TextBoxSerialNumber.Text = "Enter Here"

        DeviceHandle = 0
        OffsetValue = 0
        FullscaleValue = 0
        FullScaleLoad = 0
        DecimalPoint = 0
        UnitCode = 0
        Tare = 0

        NormalData = 0
        CalculatedReading = 0

        OpenedConnection = False
    End Sub

    Private Sub FormMain_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed

        TimerReading.Enabled = False

        If OpenedConnection = True Then
        Else
            Exit Sub
        End If

        oFutekUSBDLL.Close_Device_Connection(DeviceHandle)
        If oFutekUSBDLL.DeviceStatus <> 0 Then
            MsgBox("Device Error " & oFutekUSBDLL.DeviceStatus)
            Exit Sub
        End If

        OpenedConnection = False

    End Sub

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click

        SerialNumber = TextBoxSerialNumber.Text

        If Not IsNumeric(SerialNumber) Then
            MsgBox("The Serial Number Must Be Numeric.")
            Exit Sub
        End If


        If OpenedConnection = False Then
        Else
            Exit Sub
        End If

        oFutekUSBDLL.Open_Device_Connection(SerialNumber)
        If oFutekUSBDLL.DeviceStatus <> 0 Then
            MsgBox("Device Error " & oFutekUSBDLL.DeviceStatus)
            Exit Sub
        End If
        DeviceHandle = oFutekUSBDLL.DeviceHandle

        OpenedConnection = True
        oFutekUSBDLL.Get_Display_Page(DeviceHandle)

        GetOffsetValue()
        GetFullscaleValue()
        GetFullscaleLoad()
        GetDecimalPoint()
        GetUnitCode()
        FindUnits()

        TimerReading.Interval = 500
        TimerReading.Enabled = True

    End Sub

    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStop.Click

        TimerReading.Enabled = False

        If OpenedConnection = True Then
        Else
            Exit Sub
        End If

        oFutekUSBDLL.Close_Device_Connection(DeviceHandle)
        If oFutekUSBDLL.DeviceStatus <> 0 Then
            MsgBox("Device Error " & oFutekUSBDLL.DeviceStatus)
            Exit Sub
        End If

        OpenedConnection = False

    End Sub

    Private Sub ButtonTare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonTare.Click
        Tare = CalculatedReading
    End Sub

    Private Sub ButtonGross_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGross.Click
        Tare = 0
    End Sub

    ''' <summary>
    ''' Gets the offset value by using the FUTEK DLL Method and
    ''' check if it's numeric and then parse it into integer
    ''' then store it into the memory
    ''' </summary>
    Private Sub GetOffsetValue()
        Do
            OffsetValue = oFutekUSBDLL.Get_Offset_Value(DeviceHandle)
        Loop Until IsNumeric(OffsetValue)
    End Sub

    ''' <summary>
    ''' Gets the fullscale value by using the FUTEK DLL Method and
    ''' check if it's numeric and then parse it into integer
    ''' then store it into the memory
    ''' </summary>
    Private Sub GetFullscaleValue()
        Do
            FullscaleValue = oFutekUSBDLL.Get_Fullscale_Value(DeviceHandle)
        Loop Until IsNumeric(FullscaleValue)
    End Sub

    ''' <summary>
    ''' Gets the fullscale load by using the FUTEK DLL Method and
    ''' check if it's numeric and then parse it into integer
    ''' then store it into the memory
    ''' </summary>
    Private Sub GetFullscaleLoad()
        Do
            FullScaleLoad = oFutekUSBDLL.Get_Fullscale_Load(DeviceHandle)
        Loop Until IsNumeric(FullScaleLoad)
    End Sub

    ''' <summary>
    ''' Gets the number of decimal places by using the FUTEK
    ''' DLL Method and check if it's numeric and then parse
    ''' it into integer then store it into the memory
    ''' </summary>
    Private Sub GetDecimalPoint()
        Do
            DecimalPoint = oFutekUSBDLL.Get_Decimal_Point(DeviceHandle)
        Loop Until IsNumeric(DecimalPoint)

        If DecimalPoint > 3 Then
            DecimalPoint = 0
        End If
    End Sub

    ''' <summary>
    ''' Gets the unit code to later find unit needed for the device
    ''' by using the FUTEK DLL Method And check if it's numeric and
    ''' then parse it into integer And then store it into the memory
    ''' </summary>
    Private Sub GetUnitCode()
        Do
            UnitCode = oFutekUSBDLL.Get_Unit_Code(DeviceHandle)
        Loop Until IsNumeric(UnitCode)
    End Sub

    ''' <summary>
    ''' Uses the UnitCode from the memory to find the correct
    ''' unit for the device
    ''' </summary>
    ''' <remarks>
    ''' For more information about unit code visit
    ''' http//www.futek.com/files/docs/API/FUTEK_USB_DLL/webframe.html#UnitCodes.html
    ''' </remarks>
    Private Sub FindUnits()
        Select Case UnitCode
            Case 0
                TextBoxUnits.Text = "atm"
            Case 1
                TextBoxUnits.Text = "bar"
            Case 2
                TextBoxUnits.Text = "dyn"
            Case 3
                TextBoxUnits.Text = "ft-H2O"
            Case 4
                TextBoxUnits.Text = "ft-lb"
            Case 5
                TextBoxUnits.Text = "g"
            Case 6
                TextBoxUnits.Text = "g-cm"
            Case 7
                TextBoxUnits.Text = "g-mm"
            Case 8
                TextBoxUnits.Text = "in-H2O"
            Case 9
                TextBoxUnits.Text = "in-lb"
            Case 10
                TextBoxUnits.Text = "in-oz"
            Case 11
                TextBoxUnits.Text = "kdyn"
            Case 12
                TextBoxUnits.Text = "kg"
            Case 13
                TextBoxUnits.Text = "kg-cm"
            Case 14
                TextBoxUnits.Text = "kg/cm2"
            Case 15
                TextBoxUnits.Text = "kg-m"
            Case 16
                TextBoxUnits.Text = "klbs"
            Case 17
                TextBoxUnits.Text = "kN"
            Case 18
                TextBoxUnits.Text = "kPa"
            Case 19
                TextBoxUnits.Text = "kpsi"
            Case 20
                TextBoxUnits.Text = "lbs"
            Case 21
                TextBoxUnits.Text = "Mdyn"
            Case 22
                TextBoxUnits.Text = "mmHG"
            Case 23
                TextBoxUnits.Text = "mN-m"
            Case 24
                TextBoxUnits.Text = "MPa"
            Case 25
                TextBoxUnits.Text = "MT"
            Case 26
                TextBoxUnits.Text = "N"
            Case 27
                TextBoxUnits.Text = "N-cm"
            Case 28
                TextBoxUnits.Text = "N-m"
            Case 29
                TextBoxUnits.Text = "N-mm"
            Case 30
                TextBoxUnits.Text = "oz"
            Case 31
                TextBoxUnits.Text = "psi"
            Case 32
                TextBoxUnits.Text = "Pa"
            Case 33
                TextBoxUnits.Text = "T"
            Case 34
                TextBoxUnits.Text = "mV/V"
            Case 35
                TextBoxUnits.Text = "µA"
            Case 36
                TextBoxUnits.Text = "mA"
            Case 37
                TextBoxUnits.Text = "A"
            Case 38
                TextBoxUnits.Text = "mm"
            Case 39
                TextBoxUnits.Text = "cm"
            Case 40
                TextBoxUnits.Text = "dm"
            Case 41
                TextBoxUnits.Text = "m"
            Case 42
                TextBoxUnits.Text = "dm"
            Case 43
                TextBoxUnits.Text = "in"
            Case 44
                TextBoxUnits.Text = "ft"
            Case 45
                TextBoxUnits.Text = "yd"
            Case 46
                TextBoxUnits.Text = "mi"
            Case 47
                TextBoxUnits.Text = "µg"
            Case 48
                TextBoxUnits.Text = "mg"
            Case 49
                TextBoxUnits.Text = "LT"
            Case 50
                TextBoxUnits.Text = "mbar"
            Case 51
                TextBoxUnits.Text = "˚C"
            Case 52
                TextBoxUnits.Text = "˚F"
            Case 53
                TextBoxUnits.Text = "K"
            Case 54
                TextBoxUnits.Text = "˚Ra"
            Case 55
                TextBoxUnits.Text = "kN-m"
            Case 56
                TextBoxUnits.Text = "g-m"
            Case 57
                TextBoxUnits.Text = "nV"
            Case 58
                TextBoxUnits.Text = "µV"
            Case 59
                TextBoxUnits.Text = "mV"
            Case 60
                TextBoxUnits.Text = "V"
            Case 61
                TextBoxUnits.Text = "kV"
            Case 62
                TextBoxUnits.Text = "NONE"
            Case Else
                TextBoxUnits.Text = "Undefined"
        End Select


    End Sub

    Private Sub TimerReading_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TimerReading.Tick
        Do
            NormalData = oFutekUSBDLL.Normal_Data_Request(DeviceHandle)
        Loop Until IsNumeric(NormalData)

        CalculatedReading = (NormalData - OffsetValue) / (FullscaleValue - OffsetValue) * FullScaleLoad / (10 ^ DecimalPoint)
        TextBoxCalculatedReading.Text = Format((CalculatedReading - Tare), "0.000")
    End Sub

End Class
